#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "link_emulator/lib.h"
#include "include/utils.h"

/**
 * You can change these to communicate with another colleague.
 * There are several factors that could stop this from working over the
 * internet, but if you're on the same network it should work.
 * Just fill in their IP here and make sure that you use the same port.
 */
#define HOST "127.0.0.1"
#define PORT 10001

#include "common.h"
#define BUFFER_SIZE 32

/* Our unique layer 2 ID */
static int ID = 123131;

int recv_bytes(char *buffer, int length) {
    int i = 0;
    while (i < length) {
        char c = recv_byte();
        if (c == DLE) {
            char next = recv_byte();
            if (next == DLE) {
                buffer[i++] = DLE;
            } else {
                return -1;
            }
        } else {
            buffer[i++] = c;
        }
    }
    return i; 
}

/* Function which our protocol implementation will provide to the upper layer. */
int recv_frame(char *buf, int size)
{
	char frame;
	char frame2;

	fprintf(stderr, "1\n");
	frame = recv_byte();
	fprintf(stderr, "2\n");
	frame2 = recv_byte();
	fprintf(stderr, "3\n");

	while( ((frame != DLE) && (frame2 != STX)) || (frame == DLE && frame2 != STX)
        || (frame != DLE && frame2 == STX)) {
		frame = frame2;
		frame2 = recv_byte();
	}

	int source;
	int dest;
	(void) source;
	recv_bytes((char *)&source, sizeof(int));
    recv_bytes((char *)&dest, sizeof(int));
	if (dest != ID) {
        fprintf(stderr, "skipping\n");
        return -1;
    }

	int i;
	for (i = 0; i < size; i++) {
		char byte = recv_byte();
		if (byte == DLE) {
			char next = recv_byte();
			if (next == ETX) {
				buf[i] = '\0';
				break;
			} else if (next == DLE) {
				buf[i] = DLE;
			} else {
				return -1;
			}
		} else {
			buf[i] = byte;
		}
	}
	return i;
}

int main(int argc,char** argv){
	init(HOST,PORT);

	char buffer[BUFFER_SIZE];
	recv_frame(buffer, BUFFER_SIZE);
	printf("%s\n", buffer);

	/* TODO 3: Measure latency in a while loop for any frame that contains
	 * a timestamp we receive, print frame_size and latency */

	printf("[RECEIVER] Finished transmission\n");
	return 0;
}
