#include "common.h"
#include <arpa/inet.h>

uint8_t simple_csum(uint8_t *buf, size_t len) {

	/* TODO 1.1: Implement the simple checksum algorithm */
	uint8_t sum = 0;
	
	for (size_t i = 0; i < len; i++) {
		sum += buf[i];
	}
	return sum;
}

uint32_t crc32(uint8_t *buf, size_t len)
{
	/* TODO 2.1: Implement the CRC 32 algorithm */
	uint32_t crc = ~0;
	const uint32_t POLY = 0xEDB88320;

	for (size_t i = 0; i < len; i++) {
		crc = crc ^ buf[i];
		for (size_t j = 0; j < 8; j++) {
			if (crc & 1) {
				crc = (crc >> 1) ^ POLY;
			} else {
				crc = (crc >> 1);
			}
		}
	}
	crc = ~crc;
	return crc;
}
