#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "common.h"
#include "link_emulator/lib.h"
#include <arpa/inet.h>
#include "include/utils.h"

#define HOST "127.0.0.1"
#define PORT 10000


int main(int argc,char** argv) {
	init(HOST,PORT);

	/* Look in common.h for the definition of l3_msg */
	struct l3_msg t;

	/* We set the payload */
	sprintf(t.payload, "Hello my World of PC!");
	t.hdr.len = strlen(t.payload) + 1;

	/* Add the checksum */
	/* Note that we compute the checksum for both header and data. Thus
	 * we set the checksum equal to 0 when computing it */
	t.hdr.sum = 0;

	/* Since sum is on 32 bits, we have to convert it to network order */
	//t.hdr.sum = htonl(simple_csum((void *) &t, sizeof(struct l3_msg)));
	uint32_t temp = crc32((uint8_t *) &t, sizeof(struct l3_msg));
	printf("[SEND] len=%d; sum=0x%04x; payload=\"%s\";\n", t.hdr.len, temp, t.payload);
	/* TODO 2.0: Call crc32 function */
	t.hdr.sum = htonl(temp);
	
	/* Send the message */
	link_send(&t, sizeof(struct l3_msg));

	/* TODO 3.1: Receive the confirmation */
	/* TODO 3.2: If we received a NACK, retransmit the previous frame */
	struct l3_msg recv;
	link_recv(&recv, sizeof(struct l3_msg));
	while (strcmp(recv.payload, "NACK") == 0) {
		link_send(&t, sizeof(struct l3_msg));
		link_recv(&recv, sizeof(struct l3_msg));
	}
	
	FILE *f;
	f = fopen("input.txt", "rb");
	size_t bytes_read;
	while ((bytes_read = fread(t.payload, 1, 1500, f)) > 0) {
		t.hdr.len = bytes_read;
		t.hdr.sum = 0;
		t.hdr.sum = htonl(crc32((uint8_t *) &t, sizeof(struct l3_msg)));
		link_send(&t, sizeof(struct l3_msg));
		link_recv(&recv, sizeof(struct l3_msg));
		while (strcmp(recv.payload, "NACK") == 0) {
			link_send(&t, sizeof(struct l3_msg));
			link_recv(&recv, sizeof(struct l3_msg));
		}

	}
	fclose(f);
	/* TODO 3.3: Update this to read the content of a file and send it as
	 * chunks of that file given a MTU of 1500 bytes */

	return 0;
}
